#include <stdlib.h>
#include <stdio.h>
#include "myutil.h"
#include <cuda.h>

__global__ void kernel1(unsigned int *output)
{
	__shared__ int localmem[32];
	for(int i =0; i<1; i++)
		localmem[i]=i;
	*output = (unsigned int)localmem;
	
}
__global__ void kernel2(unsigned int *input, int *output)
{
	int *shared;
	*shared = *input;
	for(int i=0; i<1; i++)
		output[i] = shared[i];
}

int main( int argc, char** argv) 
{
	int cpu_output[32];
	//int gpu_output[32];
	//unsigned int *sharedaddress;
	CUdeviceptr gpu_output;
	CUdeviceptr sharedaddress;
	CUcontext context;
	CUdevice device;

	muRC(0, cuInit(0));
	muRC(1, cuDeviceGet(&device,0));
	muRC(2, cuCtxCreate(&context, CU_CTX_SCHED_SPIN, device));
	muRC(3, cuMemAlloc(&gpu_output, 32*4));
	muRC(4, cuMemAlloc(&sharedaddress, 4));

	CUmodule module;
	CUfunction kernel1, kernel2;
	muRC(10, cuModuleLoad(&module, "main.sm_21.cubin"));
	muRC(11, cuModuleGetFunction(&kernel1, module, "kernel1"));
	muRC(12, cuModuleGetFunction(&kernel2, module, "kernel2"));

	muRC(20, cuParamSetSize(kernel1, 4));
	muRC(21, cuParamSetv(kernel1, 0, &sharedaddress, 4));
	muRC(22, cuFuncSetBlockShape(kernel1, 1,1,1));
	muRC(33, cuLaunch(kernel1));

	muRC(30, cuParamSetSize(kernel2, 8));
	muRC(31, cuParamSetv(kernel2, 0, &sharedaddress, 4));
	muRC(32, cuParamSetv(kernel2, 4, &gpu_output, 4));
	muRC(33, cuFuncSetBlockShape(kernel2, 1,1,1));
	muRC(34, cuLaunch(kernel2));
	
	muRC(40, cuMemcpyDtoH(cpu_output, gpu_output, 32*4));
	muRC(41, cuCtxSynchronize());
	
	for(int i=0; i<32; i++)
		printf("%i:%i\n", i, cpu_output[i]);

	muRC(50, cuMemFree(gpu_output));
	muRC(51, cuMemFree(sharedaddress));
	muRC(52, cuModuleUnload(module));
	muRC(53, cuCtxDestroy(context));
	getchar();
	return 0;
}
